<html>
<head><title>Bugzero console</title></head>
<body topmargin=0>
<center>
<h2>Bugzero Console</h2>
<%@ include file="_header.jspf" %>
<%=com.websina.VersionUID.version%>
</center>
<p>
<%
  if (token != null && com.websina.servlet.SessionUtil.isAdminUser(session) == false) {
    out.print("Access denied");
    consoleEnabled = false;
  }

  String enableDebug = "Enable Debug";
  String disableDebug = "Disable Debug";

  String debug = com.websina.util.log.Log.doDebug()? disableDebug : enableDebug;
  String cmd = request.getParameter("cmd");
  if (disableDebug.equals(cmd)) {
    debug = enableDebug;
  } else if (enableDebug.equals(cmd)) {
    debug = disableDebug;
  }

  String showLog = "Log Configuration";
  String showDatabase = "DB Configuration";
  String showMetaData = "Test DB Connection";
  String showConnectionPool = "Connection Pool";
  String showJVM = "Show JVM";
%>
<center>
<% if (consoleEnabled) { %>
<form method="post">
<% if (token != null) { %>
<input type="hidden" name="token" value='<%=token%>'>
<% } %>
<table cellspacing=2 cellpadding=2 border=0>
<tr><td>
<input type="submit" name="cmd" value="<%=showLog%>">
</td><td>
<input type="submit" name="cmd" value="<%=debug%>">
</td><td>
<input type="submit" name="cmd" value="<%=showDatabase%>">
</td><td>
<input type="submit" name="cmd" value="<%=showMetaData%>">
</td><td>
<input type="submit" name="cmd" value="<%=showConnectionPool%>">
</td><td>
<input type="submit" name="cmd" value="<%=showJVM%>">
</td></tr>
</table>
</form>
</center>
<pre>
<% 
  if (showLog.equals(cmd)) {
    out.println(com.websina.util.log.Log.currentLog());
  } else if (enableDebug.equals(cmd)) {
    com.websina.util.log.Log.setDebug(true);
    out.println("Debug is enabled!");
  } else if (disableDebug.equals(cmd)) {
    com.websina.util.log.Log.setDebug(false);
    out.println("Debug is disabled!");
  } else if (showDatabase.equals(cmd)) {
    out.println(com.websina.persistence.DBManager.getConfiguration());
  } else if (showMetaData.equals(cmd)) { 
    try {
      String result = com.websina.persistence.DBManager.getMetaData();
      out.println(result);
      String[] tables = com.websina.persistence.DBManager.getAllTables();
      out.println("Tables: " + tables.length);
      for (int i=0; i<tables.length; i++) {
        out.println("    " + tables[i]);
      }
    } catch (Exception e) {
      e.printStackTrace(new java.io.PrintWriter(out));
    }
  } else if (showConnectionPool.equals(cmd)) { 
    try {
      String result = com.websina.persistence.DBManager.getConnectionPoolInfo();
      out.println(result);
    } catch (Exception e) {
      e.printStackTrace(new java.io.PrintWriter(out));
    }
  } else if (showJVM.equals(cmd)) { 
    try {
      out.println("<b>Java Runtime:</b>");
      out.println(com.websina.util.Env.getJVM());
      out.println("  OS:      " + com.websina.util.Env.getOS());
      out.println("  Locale:  " + java.util.Locale.getDefault());
      out.println("  Charset: " + com.websina.util.Env.getCharset());
      out.println("  UI:      " + com.websina.util.Label.getInstance().getLocale());

      out.println("\n<b>Classpath:</b>");
      out.println(System.getProperty("java.class.path"));

      java.security.CodeSource mailCS1 = javax.mail.Multipart.class.getProtectionDomain().getCodeSource();
      java.security.CodeSource mailCS2 = javax.activation.DataSource.class.getProtectionDomain().getCodeSource();
      java.net.URL mailURL1 = (mailCS1 != null)? mailCS1.getLocation() : null;
      java.net.URL mailURL2 = (mailCS2 != null)? mailCS2.getLocation() : null;
      out.println("\nJavaMail: javax.mail: " + ((mailURL1 != null)? mailURL1.toString() : "source not found"));
      out.println("          javax.activation: " + ((mailURL2 != null)? mailURL2.toString() : "source not found"));

      out.println("\n<b>Library path:</b>");
      out.println(com.websina.util.Env.getLibraryPath());

      out.println("\n<b>Doc root:</b>");
      out.println(application.getRealPath("/jsp"));
  
      out.println("\n<b>Web Context:</b>");
      out.println(request.getContextPath()+ " (" + application.getServerInfo() + ")");

      out.println("\n<b>lib Files:</b>");
      java.io.File file = new java.io.File(com.websina.bean.AppContext.getHome(), "lib");
      out.println(file.getPath());
      java.io.File[] fs = file.listFiles();
      if (fs != null) {
        out.println("<table cellpadding=0 cellspacing=1><tr><td rowspan=" + (fs.length+1) + " width=24>&nbsp;</td></tr>");
        java.text.DateFormat df = java.text.DateFormat.getDateTimeInstance();
        for (int i=0; i<fs.length; i++) {
          int size = 0;
          if (fs[i].isFile()) {
            java.io.FileInputStream fi = new java.io.FileInputStream(fs[i]);;
            size =  fi.available(); fi.close();
          }
          String date = df.format(new java.util.Date(fs[i].lastModified()));
          out.println("<tr><td>" + fs[i].getName() + "</td><td width=12>&nbsp;</td><td align=right>" + size + "</td><td width=12>&nbsp;</td><td>" + date + "</td></tr>");
        }
        out.println("</table>");
      }

      out.println("\n<b>ClassLoader:</b>");
      out.println(Thread.currentThread().getContextClassLoader());

      out.println("\n<b>JVM Memory Usage:</b>");
      long[] memory = com.websina.util.MemoryCounter.getMemory();
      out.println("Max: " + (memory[0]>>10) + "K   Committed: " + (memory[1]>>10) + "K   Used: " + (memory[2]>>10) + "K\n");

      String[] threads = com.websina.util.ThreadCounter.lists();
      out.println("<b>" + threads[0] + "</b>");
      for (int i=1; i<threads.length; i++) {
        out.println(threads[i]);
      }
    } catch (Exception e) {
      e.printStackTrace(new java.io.PrintWriter(out));
    }
  }
%>
</pre>
<% if (token != null) { %>
<center><a href="../jsp/admin/home.jsp">Back to Admin Home</a></center>
<p>
<% }} %>
</body></html>
