<%@ page
    import="com.websina.bean.*,com.websina.util.*"
%>
<html>
<head>
<title>Project field order (UI)</title>
<script type="text/javascript" src="../script/utils.js"></script>
<script type="text/javascript" src="script/item_mover.js"></script>
</head>
<body topmargin=0>
<%@ include file="_header.jspf" %>
<%      
  String msg = com.websina.servlet.SessionUtil.getMessage(session, request);
  String mainTitle = label.get("admin_ui");
  String subTitle = ""; 
  Project conf = null;
  if (projectId != null && projectId.trim().length()>0) {
    conf = Project.getInstance(projectId);
    mainTitle += ": ";
    subTitle = admin.getProjectDisplay(projectId);
    if (!conf.isPersisted()) {
      msg = MessageCode.get("servlet.project.not_persisted", lang);
      conf = null;
      projectId = null;
    }
  } else {
    projectId = null;
  }
%>
<%-- the title part --%>
<form style="margin-top:10px;">
<table cellpadding=0 cellspacing=0 width="100%" border=0>
  <tr><td align=right><font color="#000000"><b><%=label.get("project_label")%></b></font>&nbsp;
     <select name="project" 
        style="font-size:14px;"
        onChange="location.href='ui.jsp?projectId='+form.project.options[form.project.selectedIndex].value;">
        <%=ListMaker.makeOptionList(admin.getProjects(), currentProject) %>
        </select>
      <input type="button" class="button" value=" <%=label.get("edit_button")%> " 
      onClick="location.href='ui.jsp?projectId='+form.project.options[form.project.selectedIndex].value;" <%=(admin.getProjects().isEmpty())?"disabled":""%>>

  </td></tr>
  <tr class="f1"><td align=center height=30><font size=+1><b><%=mainTitle%></b></font>
  &nbsp;<font color="#cccc00"><b><%=subTitle%></b></font>
  </td></tr>
</table>
</form>
<center>
<p>
<%=com.websina.servlet.ServletUtil.formatMessage(msg)%>

<% if (conf == null) {
   if (msg == null) { // for instruction only %>
<table>
<tr><td height=380 valign=top>
<%=label.get("admin_common_intro")%>
</td></tr>
</table>
<% }} else { //if a project/field order is loaded for editing 
  FieldOrder fieldOrder = conf.getFieldOrder();    
  String[] optionList = fieldOrder.getFields();
  String[] textList = new String[optionList.length];
  for (int i=0; i<optionList.length; i++) {
    StringBuffer buf = new StringBuffer("&nbsp;")
                      .append(label.get(optionList[i], projectId))
                      .append(" (");
    buf.append(optionList[i]);
    buf.append(')');
    textList[i] = buf.toString();
  }
  String[] dscList = conf.getDefaultShowColumns();
  String[] dscText = null;
  String[] srcList = conf.columnFields(null);
  if (dscList != null && dscList.length != 0) {
    dscText = new String[dscList.length];
    for (int i=0; i<dscList.length; i++) {
      StringBuffer buf = new StringBuffer("&nbsp;")
                        .append(label.get(dscList[i], projectId))
                        .append(" (");
      buf.append(dscList[i]);
      buf.append(')');
      dscText[i] = buf.toString();
    }
    srcList = ArrayUtil.remove(srcList, dscList);
  }
  String[] srcText = new String[srcList.length];
  for (int i=0; i<srcList.length; i++) {
    StringBuffer buf = new StringBuffer("&nbsp;")
                      .append(label.get(srcList[i], projectId))
                      .append(" (");
    buf.append(srcList[i]);
    buf.append(')');
    srcText[i] = buf.toString();
  }
%>

<table cellpadding=0 cellspacing=0 border=0 width=95%>
<tr><td>
<%=label.get("admin_ui_text")%>
</td></tr>
</table> 

<form name="foForm" method="post" action="<%=contextPath%>/servlet/fo">
<input type="hidden" name="token" value='<%=com.websina.servlet.SessionUtil.getToken(session)%>'>
<input type="hidden" name="projectId" value="<%=projectId%>">

<table cellpadding=2 cellspacing=2 border=0 class="box">
<tr><td class="f1">
<select multiple size="<%=(optionList.length+1)%>" name="field_order">
   <%=ListMaker.makeOptionList(optionList, textList, null)%>
</select></td>
<td class="f1">
<input type="button" class="button" value=" Up " onClick="Up(form.field_order)">
<p><input type="button" class="button" value=" Dn " onClick="Down(form.field_order)">
</td></tr>

<%-- the save/reset buttons --%>
<tr><td class="f1" colspan=2 align=center height=30>
<input type="button" class="button" value="<%=label.get("save_button")%>" onClick=" 
selectAll(form.field_order);
this.disabled=true; submit();">
<input type="button" class="button" value="<%=label.get("reset_button")%>"
onClick="location.href='ui.jsp?projectId=<%=projectId%>'">
</td></tr>
</table>
</form>
<%-- end of editing project/field order --%>
<%-- default show columns --%>

<table cellpadding=0 cellspacing=0 border=0 width=95%>
<tr><td>&nbsp;</td></tr>
<tr><td>
<%=label.get("admin_ui_dsc_header")%>
<tr><td>&nbsp;</td></tr>
</td></tr>
</table> 

<form name="dscForm" method="post" action="<%=contextPath%>/servlet/project">
<input type="hidden" name="token" value='<%=com.websina.servlet.SessionUtil.getToken(session)%>'>
<input type="hidden" name="projectId" value="<%=projectId%>">
<input type="hidden" name="action" value="dsc">

<table cellpadding=2 cellspacing=2 border=0 class="box">
<tr><td class="e8" align=center>
&nbsp;<%=label.get("admin_project_fields")%>&nbsp;<br>
<select multiple size="12" name="src">
  <%=ListMaker.makeOptionList(srcList, srcText, null)%>
</select></td>
<td  class="e8" align=center width=100>
<input type="button" class="button" value="  >>  " onclick="move(form.src,form.dsc)"><br>
<input type="button" class="button" value="  <<  " onclick="move(form.dsc,form.src)">
</td>
<td class="e8" align=center>
&nbsp;<%=label.get("admin_ui_dsc")%>&nbsp;<br>
<select multiple size="12" name="dsc">
  <%=ListMaker.makeOptionList(dscList, dscText, null)%>
</select></td>
<td class="e8">
<input type="button" class="button" value=" Up " onClick="Up(form.dsc)">
<p><input type="button" class="button" value=" Dn " onClick="Down(form.dsc)">
</td></tr>

<%-- the save/reset buttons --%>
<tr><td class="f1" colspan=4 align=center height=30>
<input type="button" class="button" value="<%=label.get("save_button")%>" onClick=" 
selectAll(form.dsc);
this.disabled=true; submit();">
<input type="button" class="button" value="<%=label.get("reset_button")%>"
onClick="location.href='ui.jsp?projectId=<%=projectId%>'">
</td></tr>
</table>
</form>

<% } %>
</center>
<%com.websina.servlet.JspUtil.include(application, request, response, out, "/jsp/customizable/footer.html");%>
</body>
</html>